#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum TimestampLocator {
    #[serde(rename = "RUN_START")]
    RunStart,
    #[serde(rename = "RUN_END")]
    RunEnd,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl TimestampLocator {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            TimestampLocator::RunStart => "RUN_START",
            TimestampLocator::RunEnd => "RUN_END",
            TimestampLocator::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for TimestampLocator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for TimestampLocator {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for TimestampLocator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<TimestampLocator, conjure_object::plain::ParseEnumError> {
        match v {
            "RUN_START" => Ok(TimestampLocator::RunStart),
            "RUN_END" => Ok(TimestampLocator::RunEnd),
            v => v.parse().map(|v| TimestampLocator::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for TimestampLocator {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<TimestampLocator, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the TimestampLocator enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
